#include "client/rendering/Shaders.h"

Error Shaders::init() {
    Error error =
        world.compile("resources/shader/world.vs", "resources/shader/world.fs");
    if(error.has()) {
        return error;
    }
    error =
        ssao.compile("resources/shader/ssao.vs", "resources/shader/ssao.fs");
    if(error.has()) {
        return error;
    }
    error = ssaoBlur.compile("resources/shader/ssaoBlur.vs",
                             "resources/shader/ssaoBlur.fs");
    if(error.has()) {
        return error;
    }
    error = shadow.compile("resources/shader/worldShadow.vs",
                           "resources/shader/worldShadow.fs");
    if(error.has()) {
        return error;
    }
    error = postWorld.compile("resources/shader/worldPost.vs",
                              "resources/shader/worldPost.fs");
    if(error.has()) {
        return error;
    }
    return overlay.compile("resources/shader/overlay.vs",
                           "resources/shader/overlay.fs");
}